if(!com) var com={};
if(!com.conceptfarm) com.conceptfarm={};


com.conceptfarm.utils = {
	// get random number in range
	randomNum:function(from, to){
		return Math.floor(Math.random() * (to - from + 1) + from);
    },
	
	// holds array of all nodes from the dom
	nodes:new Array(),
	cleanWhitespace:function(element) {
		// If no element is provided, do the whole HTML document 
		element = element || document; 
		// Use the first child as a starting point 
		var cur = element.firstChild;
		
		// Go until there are no more child nodes 
		while (cur != null ) {
		// If the node is a text node, and it contains nothing but whitespace 
			if ( cur.nodeType == 3 && ! /\S/.test(cur.nodeValue) ) {
				// Remove the text node 
				element.removeChild( cur );
			// Otherwise, if it's an element 
			} else if ( cur.nodeType == 1 ) {
				// Recurse down through the document 
				
				utils.cleanWhitespace(cur);
			} 
			cur = cur.nextSibling; // Move through the child nodes
			//console.log(cur);
		}
		
	},
	
	// get all nodes in dom and populate it to nodes array
	setNodes:function(element) {
		element = element || document; 
		var cur = element.firstChild;
		//console.log(cur);
		//this.nodes.push(cur);
		// Go until there are no more child nodes 
		while (cur != null ) {
			//console.log(cur);
			// If the node is a text node, and it contains nothing but whitespace 
			/*if ( cur.nodeType == 3 && ! /\S/.test(cur.nodeValue) ) {
				// Remove the text node 
				element.removeChild( cur );
			// Otherwise, if it's an element 
			} else if ( cur.nodeType == 1 ) {
				// Recurse down through the document 
				this.getAllNodes(cur);
				
			} */
			if ( cur.nodeType == 3 && ! /\S/.test(cur.nodeValue) ) {
				
			} else if ( cur.nodeType == 1 ) {
				//console.log(cur.attributes);
				com.conceptfarm.utils.nodes.push(cur);
				com.conceptfarm.utils.setNodes(cur);
			}
			cur = cur.nextSibling; // Move through the child nodes
		}
		//console.log(com.conceptfarm.utils.nodes.length);
	},
	

	getNodes:function() {
		return com.conceptfarm.utils.nodes; 
	},
	
	// helper functions from John Resign's book Pro Javascript Techniques
	id:function(name) { 
		return document.getElementById(name);
	},
	
	tag:function(name, elem) { 
		// If the context element is not provided, search the whole document 
		return (elem || document).getElementsByTagName(name);
	},
	
	// A Generic Function for Retreiving the Text Contents of an Element
	text:function(e) {
		var t = "";
		// If an element was passed, get its children, 
		// otherwise assume it's an array 
		e = e.childNodes || e;
		
		// Look through all child nodes 
		for ( var j = 0; j < e.length; j++ ) {
			// If it's not an element, append its text value 
			// Otherwise, recurse through all the element's children 
			t += e[j].nodeType != 1 ? e[j].nodeValue : com.conceptfarm.utils.text(e[j].childNodes);
		}
		
		// Return the matched text 
		return t;
	},
	
	hasAttribute:function(elem, name) {
		return elem.getAttribute(name) != null;
	},
	
	// Getting and Setting the Values of Element Attributes
	attr:function(elem, name, value) { 
		// Make sure that a valid name was provided 
		if ( !name || name.constructor != String ) return '';
		
		// Figure out if the name is one of the weird naming cases 
		name = { 'for': 'htmlFor', 'class': 'className' }[name] || name;
		
		// If the user is setting a value, also 
		if ( typeof value != 'undefined' ) {
			// Set the quick way first 
			elem[name] = value;
			
			// If we can, use setAttribute 
			if ( elem.setAttribute ) {
				elem.setAttribute(name,value);
			}
		}
		// Return the value of the attribute 
		return elem[name] || elem.getAttribute(name) || '';
	},
	
	// A Generic Function for Creating a New DOM Element
	create:function(elem) { 
		return document.createElementNS ? document.createElementNS('http://www.w3.org/1999/xhtml', elem) : document.createElement(elem);
	},
	
	// Converting an Array of Mixed DOM Node/HTML String Arguments into a Pure Array of DOM Nodes
	checkElem:function(a) { 
		var r = [];
		// Force the argument into an array, if it isn't already 
		if ( a.constructor != Array ) a = [ a ];
		for ( var i = 0; i < a.length; i++ ) { 
			// If there's a String 
			if ( a[i].constructor == String ) {
				// Create a temporary element to house the HTML 
				var div = document.createElement("div");
				// Inject the HTML, to convert it into a DOM structure 
				div.innerHTML = a[i];
				// Extract the DOM structure back out of the temp DIV 
				for (var j = 0; j<div.childNodes.length; j++) {
					r[r.length] = div.childNodes[j]; 
				}
			} else if (a[i].length) { // If it's an array
				// Assume that it's an array of DOM Nodes 
				for (var j=0; j<a[i].length; j++) {
					r[r.length] = a[i][j]; 
				}
			} else { // Otherwise, assume it's a DOM Node
				r[r.length] = a[i];
			} 
		}
		return r;
	},
	
	// A Function for Inserting an Element Before Another Element
	before:function(parent, before, elem) { 
		// Check to see if no parent node was provided 
		if (elem == null) {
			elem = before; 
			before = parent; 
			parent = before.parentNode;
		}
		// Get the new array of elements 
		var elems = checkElem(elem);
		
		// Move through the array backwards, 
		// because we're prepending elements 
		for (var i=elems.length-1; i>= 0; i--) {
			parent.insertBefore(elems[i], before);
		}
	},
	
	// A Function for Appending an Element As a Child of Another Element
	append:function(parent, elem) {
		// Get the array of elements 
		var elems = com.conceptfarm.utils.checkElem(elem);
		
		// Append them all to the element 
		for (var i=0; i<=elems.length; i++) {
			parent.appendChild(elems[i]);
		}
	},
	
	// Remove a single Node from the DOM 
	remove:function(elem) {
		if (elem) {
			elem.parentNode.removeChild(elem);
		}
	},
	
	// Remove all of an Element's children from the DOM 
	empty:function(elem) {
		while(elem.firstChild) {
			com.conceptfarm.utils.remove(elem.firstChild);
		}
	},
	
	// get the absolute position of an element
	findPos:function(obj) {
		var curleft = curtop = 0;
		if (obj.offsetParent) {
			do {
				curleft += obj.offsetLeft;
				curtop += obj.offsetTop;

			} while (obj = obj.offsetParent);
		}
		return [curleft,curtop];
	}
}